# Class JConsole

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.JScrollPane
bsh.util.JConsole

All Implemented Interfaces:
  `ConsoleInterface, GUIConsoleInterface, ActionListener, KeyListener, MouseListener, ImageObserver, MenuContainer, PropertyChangeListener, Serializable, Runnable, EventListener, Accessible, ScrollPaneConstants`

public class JConsole extends JScrollPane implements GUIConsoleInterface, Runnable, KeyListener, MouseListener, ActionListener, PropertyChangeListener
A JFC/Swing based console for the BeanShell desktop. This is a descendant of the old AWTConsole. Improvements by: Mark Donszelmann invalid input: '<'Mark.Donszelmann@cern.ch> including Cut invalid input: '&' Paste Improvements by: Daniel Leuck including Color and Image support, key press bug workaround

See Also:
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static class`
`JConsole.BlockingPipedInputStream`
The overridden read method in this class will not throw "Broken pipe" IOExceptions; It will simply wait for new writers and data.

### Nested classes/interfaces inherited from class JScrollPane

`JScrollPane.AccessibleJScrollPane, JScrollPane.ScrollBar`

### Nested classes/interfaces inherited from class JComponent

`JComponent.AccessibleJComponent`

### Nested classes/interfaces inherited from class Container

`Container.AccessibleAWTContainer`

### Nested classes/interfaces inherited from class Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

## Field Summary

### Fields inherited from class JScrollPane

`columnHeader, horizontalScrollBar, horizontalScrollBarPolicy, lowerLeft, lowerRight, rowHeader, upperLeft, upperRight, verticalScrollBar, verticalScrollBarPolicy, viewport`

### Fields inherited from class JComponent

`listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

### Fields inherited from class Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

### Fields inherited from interface ScrollPaneConstants

`COLUMN_HEADER, HORIZONTAL_SCROLLBAR, HORIZONTAL_SCROLLBAR_ALWAYS, HORIZONTAL_SCROLLBAR_AS_NEEDED, HORIZONTAL_SCROLLBAR_NEVER, HORIZONTAL_SCROLLBAR_POLICY, LOWER_LEADING_CORNER, LOWER_LEFT_CORNER, LOWER_RIGHT_CORNER, LOWER_TRAILING_CORNER, ROW_HEADER, UPPER_LEADING_CORNER, UPPER_LEFT_CORNER, UPPER_RIGHT_CORNER, UPPER_TRAILING_CORNER, VERTICAL_SCROLLBAR, VERTICAL_SCROLLBAR_ALWAYS, VERTICAL_SCROLLBAR_AS_NEEDED, VERTICAL_SCROLLBAR_NEVER, VERTICAL_SCROLLBAR_POLICY, VIEWPORT`

## Constructor Summary

Constructors
Constructor
Description
`JConsole()`
`JConsole(InputStream cin, OutputStream cout)`

## Method Summary

Modifier and Type
Method
Description
`void`
`actionPerformed(ActionEvent event)`
`void`
`error(Object o)`
`PrintStream`
`getErr()`
`Reader`
`getIn()`
`InputStream`
`getInputStream()`
`PrintStream`
`getOut()`
`void`
`keyPressed(KeyEvent e)`
`void`
`keyReleased(KeyEvent e)`
`void`
`keyTyped(KeyEvent e)`
`void`
`mouseClicked(MouseEvent event)`
`void`
`mouseEntered(MouseEvent event)`
`void`
`mouseExited(MouseEvent event)`
`void`
`mousePressed(MouseEvent event)`
`void`
`mouseReleased(MouseEvent event)`
`void`
`print(Object o)`
`void`
`print(Object s, Color color)`
`void`
`print(Object s, Font font)`
`void`
`print(Object o, Font font, Color color)`
`void`
`print(Object s, String fontFamilyName, int size, Color color)`
`void`
`print(Object o, String fontFamilyName, int size, Color color, boolean bold, boolean italic, boolean underline)`
`void`
`print(Icon icon)`
`void`
`println()`
Prints "\\n" (i.e.
`void`
`println(Object o)`
`void`
`println(Icon icon)`
`void`
`propertyChange(PropertyChangeEvent event)`
`void`
`requestFocus()`
`void`
`run()`
`void`
`setFont(Font font)`
`void`
`setNameCompletion(NameCompletion nc)`
`void`
`setWaitFeedback(boolean on)`
e.g.
`String`
`toString()`

### Methods inherited from class JScrollPane

`createHorizontalScrollBar, createVerticalScrollBar, createViewport, getAccessibleContext, getColumnHeader, getCorner, getHorizontalScrollBar, getHorizontalScrollBarPolicy, getRowHeader, getUI, getUIClassID, getVerticalScrollBar, getVerticalScrollBarPolicy, getViewport, getViewportBorder, getViewportBorderBounds, isValidateRoot, isWheelScrollingEnabled, paramString, setColumnHeader, setColumnHeaderView, setComponentOrientation, setCorner, setHorizontalScrollBar, setHorizontalScrollBarPolicy, setLayout, setRowHeader, setRowHeaderView, setUI, setVerticalScrollBar, setVerticalScrollBarPolicy, setViewport, setViewportBorder, setViewportView, setWheelScrollingEnabled, updateUI`

### Methods inherited from class JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

### Methods inherited from class Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### JConsole

public JConsole()

### JConsole

public JConsole(InputStream cin, OutputStream cout)

## Method Details

### getInputStream

public InputStream getInputStream()

### getIn

public Reader getIn()

Specified by:
  `getIn` in interface `ConsoleInterface`

### getOut

public PrintStream getOut()

Specified by:
  `getOut` in interface `ConsoleInterface`

### getErr

public PrintStream getErr()

Specified by:
  `getErr` in interface `ConsoleInterface`

### requestFocus

public void requestFocus()

Overrides:
  `requestFocus` in class `JComponent`

### keyPressed

public void keyPressed(KeyEvent e)

Specified by:
  `keyPressed` in interface `KeyListener`

### keyTyped

public void keyTyped(KeyEvent e)

Specified by:
  `keyTyped` in interface `KeyListener`

### keyReleased

public void keyReleased(KeyEvent e)

Specified by:
  `keyReleased` in interface `KeyListener`

### println

public void println(Object o)

Specified by:
  `println` in interface `ConsoleInterface`

### print

public void print(Object o)

Specified by:
  `print` in interface `ConsoleInterface`

### println

public void println()
Prints "\\n" (i.e. newline)

### error

public void error(Object o)

Specified by:
  `error` in interface `ConsoleInterface`

### println

public void println(Icon icon)

### print

public void print(Icon icon)

### print

public void print(Object s, Font font)

### print

public void print(Object s, Color color)

Specified by:
  `print` in interface `GUIConsoleInterface`

### print

public void print(Object o, Font font, Color color)

### print

public void print(Object s, String fontFamilyName, int size, Color color)

### print

public void print(Object o, String fontFamilyName, int size, Color color, boolean bold, boolean italic, boolean underline)

### setFont

public void setFont(Font font)

Overrides:
  `setFont` in class `JComponent`

### run

public void run()

Specified by:
  `run` in interface `Runnable`

### toString

public String toString()

Overrides:
  `toString` in class `Component`

### mouseClicked

public void mouseClicked(MouseEvent event)

Specified by:
  `mouseClicked` in interface `MouseListener`

### mousePressed

public void mousePressed(MouseEvent event)

Specified by:
  `mousePressed` in interface `MouseListener`

### mouseReleased

public void mouseReleased(MouseEvent event)

Specified by:
  `mouseReleased` in interface `MouseListener`

### mouseEntered

public void mouseEntered(MouseEvent event)

Specified by:
  `mouseEntered` in interface `MouseListener`

### mouseExited

public void mouseExited(MouseEvent event)

Specified by:
  `mouseExited` in interface `MouseListener`

### propertyChange

public void propertyChange(PropertyChangeEvent event)

Specified by:
  `propertyChange` in interface `PropertyChangeListener`

### actionPerformed

public void actionPerformed(ActionEvent event)

Specified by:
  `actionPerformed` in interface `ActionListener`

### setNameCompletion

public void setNameCompletion(NameCompletion nc)

Specified by:
  `setNameCompletion` in interface `GUIConsoleInterface`

### setWaitFeedback

public void setWaitFeedback(boolean on)
Description copied from interface: `GUIConsoleInterface`
e.g. the wait cursor

Specified by:
  `setWaitFeedback` in interface `GUIConsoleInterface`